stripe = Stripe(stripeElementsInfo.stripePublishableKey);

var MM_StripeElements = Class.extend({ 
	
	pageObject: {},
	stripe: {},
	elements: {}, 
	card: {}, 
	
	init: function()
	{       
	},
	
	createElementDiv: function(el, wrapperID) {  
		if ((el != null) && (document.getElementById(wrapperID) == null))
		{
			var wrapper = document.createElement('div');
			wrapper.id = wrapperID;
		    el.parentNode.insertBefore(wrapper, el);
		    wrapper.appendChild(el);
		}
	}, 
	  
	load: function()
	{
		console.log("Building... loading form elements !");
		this.stripe = Stripe(stripeElementsInfo.stripePublishableKey); 
		 
		/// Wrap current elements with divs of which we can overwrite.
		/*
		this.createElementDiv(document.getElementById('mm_field_cc_number'), "mm_field_cc_number_div");
		this.createElementDiv(document.getElementById('mm_field_cc_cvv'), "mm_field_cc_cvv_div");
		this.createElementDiv(document.getElementById('mm_field_cc_exp_month'), "mm_field_cc_exp_div");
		var expYearNode = document.querySelector('#mm_field_cc_exp_year');
		if (expYearNode != null)
		{
			expYearNode.parentNode.removeChild(expYearNode);
		}
		*/
		
		this.elements = this.stripe.elements();
   
		this.card = this.elements.create('cardNumber', {placeholder:''});
		this.card.mount('#mm_field_cc_number_div');
		
		var cardExpiry = this.elements.create('cardExpiry', {placeholder:''});
		cardExpiry.mount('#mm_field_cc_exp_div');
		 
		var cardCvc = this.elements.create('cardCvc', {placeholder:''});
		cardCvc.mount('#mm_field_cc_cvv_div');   
		
		// Handle real-time validation errors from the card Element.
		 this.card.addEventListener('change', function(event) {
		  var displayError = document.getElementById('card-errors');
		  if(displayError!=undefined && displayError!=null){ 
			  if (event.error) {
			    displayError.textContent = event.error.message;
			  } else {
			    displayError.textContent = '';
			    console.log("good card :) ");
			  }
		  }
		  else{
			  if (event.error) {
				  console.log("Error with Stripe Elements: ");
				  console.log(event.error);
				  mmStripeElements.errorHandler(event.error.message);
			  }
		  }
		});
	},
	
	buildForm: function()
	{   
		mmStripeElements.load();
	},
	
	errorHandler: function(errorMessage)
	{ 
		alert(errorMessage);
	}, 
	
	doTokenExchange: function()
	{     
		mmStripeElements.pageObject.usePaymentTokenField = true;  

		var firstName = "";
		var lastName = "";
		var cardholderName = "";
		if (!mmStripeElements.myAccount)
	    { 
			if(jQuery("#mm_field_first_name").length)
			{
				firstName = document.getElementById('mm_field_first_name').value;
			}
			
			if(jQuery("#mm_field_last_name").length)
			{
				lastName = document.getElementById('mm_field_last_name').value;
			}  
	    }
		else{
			if(jQuery("#mm-data-first-name").length)
			{
				firstName = jQuery("#mm-data-first-name").text().trim();
			}
			
			if(jQuery("#mm-data-last-name").length)
			{
				lastName = jQuery("#mm-data-last-name").text().trim();
			}
		}
		cardholderName = firstName+" "+lastName;
		
		var cardButton = document.getElementById('card-button'); 

		if(typeof stripeSecret === 'undefined' || stripeSecret==null || stripeSecret.length<=0)
		{
			if(typeof stripeSecretError !== 'undefined' && stripeSecretError!==null && stripeSecretError.length>0)
			{
				mmStripeElements.errorHandler(stripeSecretError);
			}
			else
			{
				mmStripeElements.errorHandler("Invalid gateway configuration.");
			}
			return false;
		}
		
		var paymentMethodData = {};
		cardholderName = cardholderName.trim();
		if(cardholderName.length>0)
		{  
			paymentMethodData = {
		        billing_details: {name: cardholderName}
		    };
		}
		
		mmStripeElements.stripe.handleCardSetup(
				  stripeSecret, mmStripeElements.card, {
					  payment_method_data: paymentMethodData
				  }
	  	).then(function(result) {
	  	  console.log(result); 
		  if (result.error) {  
			var errorMessage = result.error.message; 
			mmStripeElements.errorHandler(errorMessage);
		  } else {
			  	console.log(result);
				if (mmStripeElements.myAccount)
			    { 
			    	mmStripeElements.pageObject.addPaymentTokenToForm(result.setupIntent.payment_method);  
		    		mmStripeElements.pageObject.doSubscriptionBillingUpdate(); 
			    }
		    	else{ 
			    	mmStripeElements.pageObject.addPaymentTokenToForm(result.setupIntent.payment_method);  
			    	mmStripeElements.pageObject.submitCheckoutForm(false); 
		    	}
		    	return true;
		    }
		}); 
		  
		return false; 
	}
}); 

var mmStripeElements = new MM_StripeElements();  
if ((typeof myaccount_js !== 'undefined') && (myaccount_js instanceof MM_MyAccountView))
{
	//my account page
	mmStripeElements.myAccount = true;
	mmStripeElements.pageObject = myaccount_js;   
	mmStripeElements.pageObject.usePaymentTokenField = true;
	myaccount_js.addPreUpdateCallback('onsite',mmStripeElements.doTokenExchange);  

	jQuery( ".mm-update-subscription-button" ).on( "form:loaded", function( event ) { 
		mmStripeElements.buildForm(); 
    });
}
else
{
	//checkout page 
	mmStripeElements.pageObject = mmjs;      
	mmStripeElements.pageObject.usePaymentTokenField = true;
	mmjs.addPrecheckoutCallback('onsite',mmStripeElements.doTokenExchange);

	jQuery(document).ready(function() {
		mmStripeElements.pageObject = mmjs;      
		mmStripeElements.pageObject.usePaymentTokenField = true;
		mmjs.addPrecheckoutCallback('onsite',mmStripeElements.doTokenExchange);
		mmStripeElements.buildForm();
	}); 
} 
